<?php
// $Id$

/**
 * @file
 * OM Subthemer Help
 *
 * @author: Daniel Honrade http://drupal.org/user/351112
 * 
 * Layout edit for each OM Subthemer layout
 *
 */

/**
 * Implementation of hook_help().
 *
 */
function om_subthemer_help($path, $arg) {
  $node = node_load($arg[1]);
  switch ($path) {
    // Main module help for the block module
    case 'admin/help#om_subthemer':
      return '<div class="om-subthemer-help">' . t('
                     <h3 id="help-drupal-default-variables">Drupal default page variables</h3>
                     <ul>
                       <li id="help-base-path"><strong>Base Path</strong> - The base URL path of the Drupal installation. At the very least, this will always default to /.</li>  
                       <li id="help-css"><strong>CSS</strong> - An array of CSS files for the current page.</li>  
                       <li id="help-directory"><strong>Directory</strong> - The directory the theme is located in, e.g. themes/garland or themes/garland/minelli.</li>  
                       <li id="help-is-front"><strong>Is Front</strong> - TRUE if the current page is the front page.</li>  
                       <li id="help-logged-in"><strong>Logged In</strong> - TRUE if the user is registered and signed in.</li>  
                       <li id="help-is-admin"><strong>Is Admin</strong> - TRUE if the user has permission to access administration pages.</li>   
                       <li id="help-language"><strong>Language</strong> - $language: (object) The language the site is being displayed in.
                           $language->language contains its textual representation.
                           $language->dir contains the language direction. It will either be \'ltr\' or \'rtl\'.</li>  
                       <li id="help-head-title"><strong>Head Title</strong> - A modified version of the page title, for use in the TITLE element</li>  
                       <li id="help-head"><strong>Head</strong> - Markup for the HEAD element (including meta tags, keyword tags, and so on).</li>  
                       <li id="help-styles"><strong>Styles</strong> - Style tags necessary to import all CSS files for the page.</li>  
                       <li id="help-scripts"><strong>Scripts</strong> - Script tags necessary to load the JavaScript files and settings for the page.</li>  
                       <li id="help-body-classes"><strong>Body Classes</strong> - A set of CSS classes for the BODY tag. This contains flags
                           indicating the current layout (multiple columns, single column), the
                           current path, whether the user is logged in, and so on.</li>   
                       <li id="help-front-page"><strong>Front Page</strong> - The URL of the front page. Use this instead of $base_path, when linking to the front page. This includes the language domain or prefix.</li>  
                       <li id="help-logo"><strong>Logo</strong> - The path to the logo image, as defined in theme configuration.</li>  
                       <li id="help-site-name"><strong>Site Name</strong> - The name of the site, empty when display has been disabled in theme settings.</li>  
                       <li id="help-site-slogan"><strong>Site Slogan</strong> - The slogan of the site, empty when display has been disabled in theme settings.</li>  
                       <li id="help-mission"><strong>Mission</strong> - The text of the site mission, empty when display has been disabled in theme settings.</li>  
                       <li id="help-search-box"><strong>Search Box</strong> - HTML to display the search box, empty if search has been disabled.</li>    
                       <li id="help-primary-links"><strong>Primary Links</strong> - (array): An array containing primary navigation links for the site, if they have been configured.</li>  
                       <li id="help-secondary-links"><strong>Secondary Links</strong> - (array): An array containing secondary navigation links for the site, if they have been configured.</li>  
                       <li id="help-breadcrumb"><strong>Breadcrumb</strong> - The breadcrumb trail for the current page.</li>  
                       <li id="help-title"><strong>Title</strong> - The page title, for use in the actual HTML content.</li>  
                       <li id="help-help"><strong>Help</strong> - Dynamic help text, mostly for admin pages.</li>  
                       <li id="help-messages"><strong>Messages</strong> - HTML for status and error messages. Should be displayed prominently.</li>  
                       <li id="help-tabs"><strong>tabs</strong> - Tabs linking to any sub-pages beneath the current page (e.g., the view and edit tabs when displaying a node).</li>  
                       <li id="help-node"><strong>Node</strong> - The node object, if there is an automatically-loaded node associated
                           with the page, and the node ID is the second argument in the page\'s path
                           (e.g. node/12345 and node/12345/revisions, but not comment/reply/12345).</li>  
                       <li id="help-feed-icons"><strong>Feed Icons</strong> - A string of all feed icons for the current page.</li>  
                       <li id="help-closure"><strong>Closure</strong> - Final closing markup from any modules that have altered the page. This variable should always be output last, after all other dynamic content.</li>    
                     </ul>

                     <h3 id="help-guide-base-theme">How to create OM Subthemer base theme files</h3>
                     <p>You must first install the base theme, e.g. OM, Zen, Fusion, Genesis, etc. All these files below are just helpers to format the subthemes for specific base theme, you can copy and modify existing base theme files, see OM base theme helper files at om_subthemer/base_themes/om/.</p>
                     <ul>
                       <li><strong>Layout</strong> - base_theme.layout, you can generate you own layout by using the layout edit and pasting the output on the file.</li>  
                       <li><strong>Settings</strong> - base_theme.settings, you can generate you own settings by using the settings edit and pasting the output on the file.</li>  
                       <li><strong>Stylesheets</strong> - base_theme.stylesheets, these are base theme stylesheet files to include, see om.stylesheets sample.</li>  
                       <li><strong>Scripts</strong> - base_theme.scripts, these are base theme script files to include, see om.scripts sample.</li> 
                       <li><strong>Templates</strong> - templates/template.php and other templates, e.g. node.tpl.php, to include from the base theme if needed.</li>   
                     </ul>

                     <h3 id="help-guide-skin">How to create OM Subthemer skin files</h3>
                     <p>All these files must be present, you can copy and modify existing skin files, see OM Black skin files at om_subthemer/skins/om_black/.</p>
                     <ul>
                       <li><strong>Logo</strong> - Default logo image</li>  
                       <li><strong>Favicon</strong> - Default favicon.ico</li>  
                       <li><strong>Screenshot</strong> - Default screenshot</li>  
                       <li><strong>CSS</strong> - css/style.css, css/ie.css, css/ie6.css, css/ie7.css, css/ie8.css, css/ie9.css</li>  
                       <li><strong>Script</strong> - js/script.js</li>  
                     </ul>
                     
                     ') . '</div>';

    case 'admin/settings/om-subthemer':
      return t('<p>The OM Subthemer will be attached to the following content types if checked.</p>
                <ul>
                  <li><strong>Base Theme</strong> - You can add more base themes on /om_subthemer/base_themes folder. Follow the <a href="@guide_base_theme">guide</a> on creating base theme files.</li>
                  <li><strong>Skins</strong> - You can add more custom skins on /om_subthemer/skins/ folder. Follow the <a href="@guide_skin">guide</a> on creating skin files.</li>
                </ul>',
                array(
                '@guide_base_theme' => base_path() . 'admin/help/om_subthemer#help-guide-base-theme', 
                '@guide_skin' => base_path() . 'admin/help/om_subthemer#help-guide-skin'));

    case 'admin/settings/om-subthemer/' . $arg[3]:
      return '<p>' . t('These are current available variables for this base theme.') . '</p>';

    case 'admin/settings/om-subthemer/' . $arg[3] . '/import':
      return '<p>' . t('Importing settings will automatically delete existing settings for this type.') . '</p>';

    case 'node/%/om-skin':
      return t('<p>These are the current available skins.</p>
                <ul>
                  <li><strong>Skins</strong> - You can add more custom skins on /om_subthemer/skins/ folder. Follow the <a href="@guide_skin">guide</a> on creating skin files.</li>
                </ul>',
                array('@guide_skin' => base_path() . 'admin/help/om_subthemer#help-guide-skin'));

    // Help appears on om-layout
    // known D6 bug: url() doesn't properly encode '#' or '%'
    case 'node/%/om-layout':
      return '<ul>' . t('
                     <li><strong>Variables</strong> are automatically identified by the system via their names. 
                     Click <a href="@variables">here</a> to see all Drupal default variables. 
                     If you want to change/add the default html and php values of these variables, 
                     click <a href="@settings">here</a>. Variables cannot have inner wrappers or inner divs.</li>
                     <li><strong>Regions</strong> are elements without other elements nested under them, or without \'children\' and not identified as variables. Regions can have inner wrappers or inner divs.</li> 
                     <li><strong>Wrappers</strong> are elements with other elements nested under them, or with \'children\'. Wrappers can have inner wrappers or inner divs.</li>
                     <li><strong>Reset to default layout</strong> can be done by deleting all existing variables, region, wrappers. Deleting a wrapper will automatically delete all elements nested under it, or delete all its children.</li>', 
                     array(
                     '@variables' => base_path() . 'admin/help/om_subthemer#help-drupal-default-variables', 
                     '@settings' => url('admin/settings/om-subthemer/' . $node->type))) . '</ul>';
    case 'node/%/om-layout/import':
      return '<p>' . t('Importing layout will automatically delete existing layout for this node.') . '</p>';

    case 'node/%/om-blocks':
      return '<p>' . t('Click <a href="@regions">here</a> to add/update regions. These are just dummy blocks which you can use for previewing subthemes. You can add any block from Drupal html output. You can copy and paste directly from your browser\'s source output, ex. &lt;div id="block-block-1"&gt;&lt;div ...&lt;/div&gt;.', 
                     array('@regions' => url('node/' . $node->nid . '/om-layout'))) . '</p>';

    case 'node/%/om-blocks/import':
      return '<p>' . t('Importing blocks will automatically delete all existing blocks for this node.') . '</p>';

  }
}



